/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.communication.topology;

import java.util.Map;

import javax.naming.ConfigurationException;

import org.ow2.petals.clientserverapi.configuration.ContainerConfiguration;
import org.ow2.petals.clientserverapi.configuration.ContainerConfiguration.RegistryMode;
import org.ow2.petals.microkernel.api.configuration.DomainConfiguration;
import org.ow2.petals.microkernel.api.configuration.SubDomainConfiguration;
import org.ow2.petals.topology.generated.SubdomainMode;

/**
 * @author Charles Casadei - EBM WebSourcing
 */
public class DynamicTopologyValidatorImpl implements DynamicTopologyValidator {

    public void validateTopology(DomainConfiguration domainConfiguration, Map<String, SubDomainConfiguration> subdomainConfiguration, Map<String, ContainerConfiguration> containers) throws ConfigurationException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void validateContainerConfiguration(SubDomainConfiguration subdomainConfiguration, ContainerConfiguration container) throws ConfigurationException {
        
    }

    private void checkContainerMode(SubdomainMode subdomainMode, RegistryMode containerMode) throws ConfigurationException {
        if (subdomainMode.equals(SubdomainMode.FLOODING) && ! containerMode.equals(RegistryMode.PEER)) {
            StringBuilder errorSB = new StringBuilder();
            errorSB.append("A ")
                    .append(SubdomainMode.FLOODING)
                    .append(" topology can't contain node of type : ")
                    .append(containerMode)
                    .append(" . (Valid type are : ")
                    .append(RegistryMode.PEER)
                    .append(")");
            throw new ConfigurationException(errorSB.toString());
        }
        if (subdomainMode.equals(SubdomainMode.STANDALONE) && ! containerMode.equals(RegistryMode.STANDALONE)) {
            StringBuilder errorSB = new StringBuilder();
            errorSB.append("A ")
                    .append(SubdomainMode.STANDALONE)
                    .append(" topology can't contain node of type : ")
                    .append(containerMode)
                    .append(" . (Valid type are : ")
                    .append(RegistryMode.STANDALONE)
                    .append(")");
            throw new ConfigurationException(errorSB.toString());
        }
        if (subdomainMode.equals(SubdomainMode.MASTER_SLAVE) && 
                ! (containerMode.equals(RegistryMode.PEER) || containerMode.equals(RegistryMode.STANDALONE))) {
            StringBuilder errorSB = new StringBuilder();
            errorSB.append("A ")
                    .append(SubdomainMode.STANDALONE)
                    .append(" topology can't contain node of type : ")
                    .append(containerMode)
                    .append(" . (Valid type are : ")
                    .append(RegistryMode.MASTER)
                    .append(RegistryMode.SLAVE)
                    .append(")");
            throw new ConfigurationException(errorSB.toString());
        }
    }

    

}
