/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.management.task;

import org.ow2.petals.clientserverapi.configuration.ContainerConfiguration;
import org.ow2.petals.microkernel.api.jbi.management.Task;
import org.ow2.petals.microkernel.api.util.LoggingUtil;

/**
 * This class manages the logger for all the implementations of a task.
 * @author Frederic Gardes - EBM WebSourcing
 */
public abstract class AbstractLoggableTask implements Task {

    /**
     * logger wrapper
     */
    final protected LoggingUtil log;

    /**
     * Container configuration
     */
    final protected ContainerConfiguration containerConfiguration;

    /**
     * The constructor with a logger
     */
    public AbstractLoggableTask(final LoggingUtil log,
            final ContainerConfiguration containerConfiguration) {
        super();
        this.log = log;
        this.containerConfiguration = containerConfiguration;
    }

}
