/**
 * Copyright (c) 2005-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.messaging.exchange.types;

import javax.jbi.messaging.InOnly;
import javax.jbi.messaging.MessagingException;
import javax.jbi.messaging.NormalizedMessage;

import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfOperation;
import org.ow2.petals.jbi.messaging.exchange.MessageExchangeImpl;
import org.ow2.petals.microkernel.jbi.messaging.exchange.PersistedMessageExchangeWrapper;

/**
 * @author Adrien LOUIS - EBM WebSourcing
 */
public class InOnlyImpl extends PersistedMessageExchangeWrapper implements InOnly {

    public InOnlyImpl(MessageExchangeImpl me, Role observerRole) {
        super(me, observerRole);

        me.setPattern(AbsItfOperation.MEPPatternConstants.IN_ONLY.value());
    }

    /*
     * (non-Javadoc)
     * @see javax.jbi.messaging.InOnly#getInMessage()
     */
    public NormalizedMessage getInMessage() {
        return this.getMessage(MessageExchangeImpl.IN_MSG);
    }

    /*
     * (non-Javadoc)
     * @see javax.jbi.messaging.InOnly#setInMessage(javax.jbi.messaging.NormalizedMessage)
     */
    public void setInMessage(NormalizedMessage msg) throws MessagingException {
        this.setMessage(msg, MessageExchangeImpl.IN_MSG);
    }
}
