/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.system.systemstate.exception;

import org.ow2.petals.systemstate.SystemStateException;

public class SharedLibraryAlreadyExistsException extends SystemStateException {

    private static final long serialVersionUID = -1980658587424589386L;

    private final String slName;
    private final String version;

    public SharedLibraryAlreadyExistsException(final String slName, final String version) {
        super("Shared library '" + slName + ", " + version + "' already registered in the system state.");
        this.slName = slName;
        this.version = version;
    }

    public String getSharedLibraryName() {
        return this.slName;
    }

    public String getVersion() {
        return this.version;
    }

}
