/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.transport;

import org.ow2.petals.jbi.messaging.exchange.MessageExchangeWrapper;

/**
 * @author Roland NAUDIN - EBM WebSourcing
 */
public interface TransportListener {

    /**
     * Receive a Message Exchange.
     * 
     * @param exchange
     */
    void onExchange(MessageExchangeWrapper exchangeDecorator);
    
    /**
     * The Message Exchange has been sent.
     * 
     * @param exchange
     */
    void exchangeSent(MessageExchangeWrapper exchangeDecorator);

}
