/**
 * Copyright (c) 2005-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.component.mock;

import java.util.List;
import java.util.Map;

import javax.jbi.JBIException;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.IllegalBindingException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.ow2.petals.jbi.descriptor.original.generated.LinkType;
import org.ow2.petals.microkernel.api.jbi.messaging.registry.EndpointRegistry;
import org.ow2.petals.microkernel.api.jbi.messaging.registry.RegistryException;
import org.ow2.petals.microkernel.api.jbi.messaging.registry.RegistryListener;
import org.w3c.dom.Document;

/**
 * Mock object of the EndpointRegistry.
 * @author ddesjardins - EBM WebSourcing
 * @author wjoseph - EBM WebSourcing
 */
public class MockEndpointRegistry implements EndpointRegistry {

    private boolean deactivateEndpoint;

    private boolean deregisterInternalEndpoint;

    private boolean deregisterExternalEndpoint;

    private boolean getEndpoint;

    private boolean getInternalEndpointsForInterface;

    private boolean getInternalEndpointsForService;

    private boolean getExternalEndpointsForInterface;

    private boolean getExternalEndpointsForService;

    private boolean registerExternalEndpoint;

    // public org.ow2.petals.jbi.messaging.endpoint.ServiceEndpoint
    // activateEndpoint(
    // QName serviceName, String endpointName, ConsumerEndpoint address)
    // throws RegistryException {
    // return new InternalEndpoint(serviceName, endpointName, "compo", "0",
    // "subdomain", this);
    // }

    public void bindFc(String arg0, Object arg1) throws NoSuchInterfaceException,
            IllegalBindingException, IllegalLifeCycleException {
    }

    public void registerConnection(QName consInterface, QName provService, String provEndpoint)
            throws RegistryException {
    }

    public void registerConnection(QName consService, String consEndpoint, QName provService,
            String provEndpoint) throws RegistryException {
        throw new RegistryException("createConnection testing exception");
    }

    public void deactivateEndpoint(ServiceEndpoint endpoint) throws RegistryException {
        this.deactivateEndpoint = true;
    }

    public void deregisterConnection(QName consInterface, QName provService, String provEndpoint)
            throws RegistryException {
    }

    public void deregisterConnection(QName consService, String consEndpoint, QName provService,
            String provEndpoint) throws RegistryException {
    }

    public void deregisterExternalEndpoint(ServiceEndpoint endpoint) throws RegistryException {
        this.deregisterExternalEndpoint = true;
    }

    public void deregisterInternalEndpoint(ServiceEndpoint endpoint) throws JBIException {
        this.deregisterInternalEndpoint = true;
    }

    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint getEndpoint(
            QName service,
            String name) {
        this.getEndpoint = true;
        return null;
    }

    public ServiceEndpoint getEndpoint(QName service, String name, boolean resolve) {
        this.getEndpoint = true;
        return null;
    }

    public Document getEndpointDescriptorForEndpoint(ServiceEndpoint endpoint) {
        return null;
    }

    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] getExternalEndpointsForInterface(
            QName interfaceName) {
        this.getExternalEndpointsForInterface = true;
        return new org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] {};
    }

    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] getExternalEndpointsForService(
            QName serviceName) {
        this.getExternalEndpointsForService = true;
        return new org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] {};
    }

    public String getFcState() {
        return null;
    }

    public ServiceEndpoint[] getInternalEndpointsForInterface(QName interfaceName) {
        this.getInternalEndpointsForInterface = true;
        return new ServiceEndpoint[] {};
    }

    public ServiceEndpoint[] getInternalEndpointsForService(QName serviceName) {
        this.getInternalEndpointsForService = true;
        return new ServiceEndpoint[] {};
    }

    public boolean isDeactivateEndpoint() {
        return this.deactivateEndpoint;
    }

    public boolean isDeregisterExternalEndpoint() {
        return this.deregisterExternalEndpoint;
    }

    public boolean isDeregisterInternalEndpoint() {
        return this.deregisterInternalEndpoint;
    }

    public boolean isGetEndpoint() {
        return this.getEndpoint;
    }

    public boolean isGetExternalEndpointsForInterface() {
        return this.getExternalEndpointsForInterface;
    }

    public boolean isGetExternalEndpointsForService() {
        return this.getExternalEndpointsForService;
    }

    public boolean isGetInternalEndpointsForInterface() {
        return this.getInternalEndpointsForInterface;
    }

    public boolean isGetInternalEndpointsForService() {
        return this.getInternalEndpointsForService;
    }

    public boolean isRegisterExternalEndpoint() {
        return this.registerExternalEndpoint;
    }

    public String[] listFc() {
        return null;
    }

    public Object lookupFc(String arg0) throws NoSuchInterfaceException {
        return null;
    }

    public void registerExternalEndpoint(ServiceEndpoint externalEndpoint) throws RegistryException {
        this.registerExternalEndpoint = true;
    }

    public void setDeactivateEndpoint(boolean deactivateEndpoint) {
        this.deactivateEndpoint = deactivateEndpoint;
    }

    public void setDeregisterExternalEndpoint(boolean deregisterExternalEndpoint) {
        this.deregisterExternalEndpoint = deregisterExternalEndpoint;
    }

    public void setDeregisterInternalEndpoint(boolean deregisterInternalEndpoint) {
        this.deregisterInternalEndpoint = deregisterInternalEndpoint;
    }

    public void setGetEndpoint(boolean getEndpoint) {
        this.getEndpoint = getEndpoint;
    }

    public void setGetExternalEndpointsForInterface(boolean getExternalEndpointsForInterface) {
        this.getExternalEndpointsForInterface = getExternalEndpointsForInterface;
    }

    public void setGetExternalEndpointsForService(boolean getExternalEndpointsForService) {
        this.getExternalEndpointsForService = getExternalEndpointsForService;
    }

    public void setGetInternalEndpointsForInterface(boolean getInternalEndpointsForInterface) {
        this.getInternalEndpointsForInterface = getInternalEndpointsForInterface;
    }

    public void setGetInternalEndpointsForService(boolean getInternalEndpointsForService) {
        this.getInternalEndpointsForService = getInternalEndpointsForService;
    }

    public void setRegisterExternalEndpoint(boolean registerExternalEndpoint) {
        this.registerExternalEndpoint = registerExternalEndpoint;
    }

    public void startFc() throws IllegalLifeCycleException {
    }

    public void stopFc() throws IllegalLifeCycleException {
    }

    public void unbindFc(String arg0) throws NoSuchInterfaceException, IllegalBindingException,
            IllegalLifeCycleException {
    }

    public List<Map<String, Object>> getAllEndpoints() {
        return null;
    }

    public List<Map<String, Object>> getAllExternalEndpoints() {
        return null;
    }

    public List<Map<String, Object>> getAllInternalEndpoints() {
        return null;
    }

    public String getDescription(String serviceName, String endpointName) {
        return null;
    }

    public void updateNewEndpoints(boolean remoteContainerInvocation) throws JBIException {
        // TODO Auto-generated method stub
    }

    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] getInternalEndpointsForInterface(
            QName interfaceName, LinkType linktype) {
        // TODO Auto-generated method stub
        return null;
    }

    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint[] getInternalEndpointsForService(
            QName serviceName, LinkType linktype) {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public List<org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint> getEndpoints()
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public List<org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint> getExternalEndpoints()
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public List<org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint> getInternalEndpoints()
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint activateEndpoint(
            QName serviceName, String endpointName,
            org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint address)
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint activateEndpoint(
            QName serviceName, String endpointName, List<QName> interfaces, Document description,
            org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint address)
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public void deactivateEndpoint(String endpointName, QName serviceName) throws RegistryException {
        // TODO Auto-generated method stub

    }

    /**
     * {@inheritDoc}
     */
    public void deregisterExternalEndpoint(String endpointName, QName serviceName)
            throws RegistryException {
        // TODO Auto-generated method stub

    }

    /**
     * {@inheritDoc}
     */
    public Document getEndpointDescriptorForEndpoint(
            org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint endpoint)
            throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public QName[] getInterfacesForEndpoint(
            org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint endpoint) {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public List<org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint> query(
            String endpoint,
            QName interfaces, QName service, String containerName, String componentName,
            String subDomainName, String type) throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public void removeAllLocalEndpoints() throws RegistryException {
        // TODO Auto-generated method stub

    }

    /**
     * {@inheritDoc}
     */
    public List<RegistryListener> getListeners() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * {@inheritDoc}
     */
    public org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint activateEndpoint(
            QName serviceName, String endpointName, QName[] interfaces, Document description,
            org.ow2.petals.microkernel.api.jbi.messaging.ServiceEndpoint address,
            Map<String, String> properties) throws RegistryException {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void synchronizeRegistry() throws RegistryException {
        // TODO Auto-generated method stub
        
    }
}
