/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.management.task.download.jetty.servlets;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URI;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;

/**
 * @author Sandra Trino - EBM WebSourcing
 */
public class InformationsForAllServlet extends HttpServlet {

    private static final long serialVersionUID = -2907062744149926108L;

    public String fileName;

    public void setsHeaderAndDateHeaderInResponse(HttpServletResponse resp) {
        resp.setHeader("Cache-Control", "no-cache"); // HTTP 1.1
        resp.setHeader("Pragma", "no-cache"); // HTTP 1.0
        resp.setDateHeader("Expires", 0); // prevents caching at the proxy
    }

    public OutputStream createOutputStream(HttpServletResponse resp) throws IOException,
            ServletException {
        OutputStream output = resp.getOutputStream();
        InputStream inputStream = null;
        try {
            inputStream = new FileInputStream(createFile());

            IOUtils.copy(inputStream, output);

            output.flush();
        } catch (Exception e) {
            throw new ServletException("Can't read file content", e);
        } finally {
            if (output != null) {
                output.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }
        }
        return output;
    }

    private File createFile() {

        String baseDirPath = this.getClass().getResource(".").getPath();
        baseDirPath = baseDirPath.substring(0, baseDirPath.indexOf("org"));

        return new File(URI.create("file:" + baseDirPath + "work/" + fileName));

    }
}
