/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.messaging.routing.mock;

import javax.jbi.JBIException;

import org.ow2.petals.jbi.messaging.exchange.MessageExchangeImpl;
import org.ow2.petals.microkernel.jbi.component.context.ComponentContextImpl;
import org.ow2.petals.microkernel.jbi.messaging.exchange.DeliveryChannelImpl;

/**
 * Mock object of the DeliveryChannelImpl.
 * @author ddesjardins - EBM WebSourcing
 */
public class MockDeliveryChannelImpl extends DeliveryChannelImpl {

	public MockDeliveryChannelImpl(ComponentContextImpl context) {
		super(context);
	}

	private boolean push = false;

	private boolean failPush = false;

	protected boolean throwException;

	public boolean push(MessageExchangeImpl msg) throws JBIException {
		if (throwException) {
			throw new JBIException("error");
		}
		if (failPush == true) {
			return false;
		}
		return push = true;
	}

	public boolean isPush() {
		return push;
	}

	public void setPush(boolean push) {
		this.push = push;
	}

	public void setFailPush(boolean failPush) {
		this.failPush = failPush;
	}

	public boolean isThrowException() {
		return throwException;
	}

	public void setThrowException(boolean throwException) {
		this.throwException = throwException;
	}

}
