/**
 * Copyright (c) 2005-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.system.classloader;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import java.net.URL;
import java.util.ArrayList;

import org.junit.Before;
import org.junit.Test;
import org.ow2.petals.basisapi.exception.PetalsException;
import org.ow2.petals.microkernel.api.util.LoggingUtil;

/**
 * Tests of the ClassLoaderServiceImpl.
 * @author ddesjardins - EBM WebSourcing
 */
public class LoaderManagerImplTest {

    ClassLoaderServiceImpl classLoaderServiceImpl = null;

    @Before
    public void setUp() {
        classLoaderServiceImpl = new ClassLoaderServiceImpl();
        classLoaderServiceImpl.log = new LoggingUtil(null);
    }

    @Test
    public void testContainsClassLoader() {
        assertFalse(classLoaderServiceImpl.containsClassLoader("foo"));
    }

    @Test
    public void testCreateComponentClassLoader() throws PetalsException {
        assertNotNull(classLoaderServiceImpl.createComponentClassLoader("foo", new URL[0],
                new ArrayList<String>(), true, new ArrayList<String>()));
    }

    @Test
    public void testDeleteClassLoader() throws PetalsException {
        assertFalse(classLoaderServiceImpl.containsClassLoader("bar"));
        classLoaderServiceImpl.createComponentClassLoader("bar", new URL[0],
                new ArrayList<String>(), true, new ArrayList<String>());
        assertTrue(classLoaderServiceImpl.containsClassLoader("bar"));
        classLoaderServiceImpl.deleteClassLoader("bar");
        assertFalse(classLoaderServiceImpl.containsClassLoader("bar"));
    }

}
