/**
 * Copyright (c) 2005-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.system.classloader.factory;

import static org.junit.Assert.assertEquals;

import java.io.File;
import java.io.IOException;
import java.net.URL;

import org.junit.Before;
import org.junit.Test;

/**
 * Test the JarURLFactory.
 * @author ddesjardins - EBM WebSourcing
 */
public class JarURLFactoryTest {

    private String baseDir;

    @Before
    public void setUp() {
        baseDir = this.getClass().getResource(".").toString();
        baseDir = baseDir.substring(0, baseDir.indexOf("target"));
        baseDir = baseDir.substring(baseDir.indexOf(":") + 1);
    }

    @Test
    public void testGetURL() throws IOException {
        JarURLFactory factory = new JarURLFactory(new URL("file:"
                + baseDir.replace(File.separator, "/") + "src/test/resources/petals-core-test.jar"));
        URL url = factory.getURL("META-INF/MANIFEST.MF");
        assertEquals(url, new URL("jar:file:" + baseDir.replace(File.separator, "/")
                + "src/test/resources/petals-core-test.jar!/META-INF/MANIFEST.MF"));
    }

    @Test
    public void testGetURLException() throws IOException {
        URL url = new URL("file:" + baseDir.replace(File.separator, "/")
                + "src/test/resources/petals-core-test.jar");
        JarURLFactory factory = new JarURLFactory(url);
        assertEquals(url, factory.getURL(""));
    }

}
